#pragma once

#include "SmeexStructs.h"

ref class CSmeexHandler
{
	public:
		CSmeexHandler(void);
		virtual ~CSmeexHandler();
		BOOL DoSmeexExport(const CString &strFilename,structSmeexOnePatientComm *psSmeexOnePatientComm);
		BOOL DoSmeexImport(const CString &strFilename,const CString &strAttachmentDir,structSmeexOnePatientComm *psSmeexOnePatientComm);
	private:
		structSmeexOnePatientComm *f_psSmeexOnePatientComm;
		System::String ^f_strAttachmentDir;
		//
		void DoExportProcessingInfo(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure);
		void DoImportProcessingInfo(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure);
		//
		void DoExportAuthor(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo);
		void DoImportAuthor(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo);
		void DoExportRecipient(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo);
		void DoImportRecipient(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo);
		void DoExportSoftware(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo);
		void DoImportSoftware(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo);
		//
		void DoExportPatientInfo(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientInfo ^pPatientInfo);
		void DoImportPatientInfo(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientInfo ^pPatientInfo);
		//
		void DoExportKg(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG);
		void DoImportKg(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG);
		void DoExportMedication(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG);
		void DoImportMedication(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG);
		void DoExportDiagnosis(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG);
		void DoRawExportDiagnosis(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG,
				const long &lParentID,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Diagnosis::DiagnosisPtrCollection ^pDiagnosisCollection);
		void DoImportDiagnosis(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG);
		void DoRawImportDiagnosis(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
				const long &lParentID,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Diagnosis ^pDiagnosis);
		//
		void DoExportDocumentTree(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientInfo ^pPatientInfo);
		void DoImportDocumentTree(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::DocumentTree ^pDocumentTree);
		//
		void DoExportDocument(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
			const structSmeexDocument *psDocument);
		void DoImportDocument(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Document ^pDocument,
			structSmeexDocument &sSmeexDocument);
		//
		void DoExportAddress(const structSmeexAddress *psAddress,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress);
		void DoImportAddress(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress,structSmeexAddress *psAddress);
#ifdef _DEBUG
		void DoTraceAddress(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress);
#endif
		//
		BOOL IsValidDate(const DATE &date);
		//
		System::Collections::Generic::Dictionary< long, Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^ > f_mapAddress;
		System::Collections::Generic::Dictionary< long, Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Document ^ > f_mapDocument;
		System::Collections::Generic::Dictionary< System::String ^, Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::CodingEntry ^ > f_mapCodingEntry;
		//
		CString BuildCodingEntryKey(const _bstr_t &strCodingEntryCode,const _bstr_t &strCodingEntryName);
		System::Collections::Generic::Dictionary< long, long > f_mapDiagnosisImportParentID;
		System::Collections::Generic::Dictionary< long, long > f_mapDiagnosisImportAddedID;
		System::Collections::Generic::Dictionary< long, long > f_mapDocumentsImportedID;
};
