#ifndef __SMEEXSTRUCTS_H__
#define __SMEEXSTRUCTS_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// smeexstructs.h : header file
//

#define SMEEX_EMPTY_OLEDATETIME	1700,1,1,0,0,0

#define SMEEX_STR_LANGUAGE_GERMAN	_T("de")
#define SMEEX_STR_LANGUAGE_FRENCH	_T("fr")
#define SMEEX_STR_LANGUAGE_ITALIAN	_T("it")

typedef enum enumSmeexAddressType {
	eUnknownSmeexAddressType = 0,
	ePersonSmeexAddressType = 1,
	eCompanySmeexAddressType = 2,
};

#define INIT_SMEEXADDRESSSTRUCT(s) \
	s.lID = 0; \
	s.eSex = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Person::EnumSex::Unknown; \
	s.eSmeexAddressType = eUnknownSmeexAddressType; \
	s.strTitle = _T(""); \
	s.strSalutation = _T(""); \
	s.strLastName = _T(""); \
	s.strMaidenname = _T(""); \
	s.strFirstName = _T(""); \
	s.strStreet = _T(""); \
	s.strSubaddress = _T(""); \
	s.strPoBox = _T(""); \
	s.strZip = _T(""); \
	s.strCity = _T(""); \
	s.strCanton = _T(""); \
	s.strCountry = _T(""); \
	s.strSpecialty1 = _T(""); \
	s.strSpecialty2 = _T(""); \
	s.strPhoneOffice = _T(""); \
	s.strPhoneHome = _T(""); \
	s.strNatelOffice = _T(""); \
	s.strNatelHome = _T(""); \
	s.strFaxOffice = _T(""); \
	s.strFaxHome = _T(""); \
	s.strMailOffice = _T(""); \
	s.strMailHome = _T(""); \
	s.strUrlOffice = _T(""); \
	s.strUrlHome = _T(""); \
	s.strEAN = _T(""); \
	s.strNIF = _T(""); \
	s.strZSR = _T(""); \
	s.strRegNumber = _T(""); \

typedef struct structSmeexAddress {
	long lID;
	enumSmeexAddressType eSmeexAddressType;
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Person::EnumSex eSex;
	_bstr_t strTitle;
	_bstr_t strSalutation;
	_bstr_t strLastName;
	_bstr_t strMaidenname;
	_bstr_t strFirstName;
	_bstr_t strStreet;
	_bstr_t strSubaddress;
	_bstr_t strPoBox;
	_bstr_t strZip;
	_bstr_t strCity;
	_bstr_t strCanton;
	_bstr_t strCountry;
	_bstr_t strSpecialty1;
	_bstr_t strSpecialty2;
	_bstr_t strPhoneOffice;
	_bstr_t strPhoneHome;
	_bstr_t strNatelOffice;
	_bstr_t strNatelHome;
	_bstr_t strFaxOffice;
	_bstr_t strFaxHome;
	_bstr_t strMailOffice;
	_bstr_t strMailHome;
	_bstr_t strUrlOffice;
	_bstr_t strUrlHome;
	_bstr_t strEAN;
	_bstr_t strNIF;
	_bstr_t strZSR;
	_bstr_t strRegNumber;
} structSmeexAddress, *structSmeexAddressPtr;

#define INIT_SMEEXSOFTWARESTRUCT(s) \
	s.strName = _T(""); \
	s.strVersion = _T(""); \
	s.strCopyright = _T(""); \
	INIT_SMEEXADDRESSSTRUCT(s.sManufacturer); \

typedef struct structSmeexSoftware {
	_bstr_t strName;
	_bstr_t strVersion;
	_bstr_t strCopyright;
	structSmeexAddress sManufacturer;
} structSmeexSoftware, *structSmeexSoftwarePtr;

#define INIT_SMEEXARCHIVESTRUCT(s) \
	s.strSmeexID = _T(""); \
	s.strTemplateSmeexId = _T(""); \
	s.strTitle = _T(""); \
	s.strLanguage = SMEEX_STR_LANGUAGE_GERMAN; \

typedef struct structSmeexArchive {
	_bstr_t strSmeexID;
	_bstr_t strTemplateSmeexId;
	_bstr_t strTitle;
	_bstr_t strLanguage;
} structSmeexArchive, *structSmeexArchivePtr;

#define INIT_PROCESSINGINFOSTRUCT(s) \
	s.dDate = 0.0; \
	s.strTitle = _T(""); \
	INIT_SMEEXADDRESSSTRUCT(s.sAuthor); \
	INIT_SMEEXADDRESSSTRUCT(s.sRecipient); \
	INIT_SMEEXSOFTWARESTRUCT(s.sSoftware); \

typedef struct structProcessingInfo {
	DATE dDate;
	_bstr_t strTitle;
	structSmeexAddress sAuthor;
	structSmeexAddress sRecipient;
	structSmeexSoftware sSoftware;
} structProcessingInfo, *structProcessingInfoPtr;

#define INIT_PATIENTADDRESSSTRUCT(s) \
	s.lAddressRefID = 0; \
	s.lPatientID = 0; \
	s.eStatusType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientAddress::EnumStatusType::Active; \
	s.dBirthdate = COleDateTime(SMEEX_EMPTY_OLEDATETIME); \
	s.strSsn = _T(""); \
	s.strProfession = _T(""); \
	s.strNationality = _T(""); \
	s.strDenomination = _T(""); \
	s.strHmoAffiliation = _T(""); \
	s.strNationalLanguage = SMEEX_STR_LANGUAGE_GERMAN; \
	s.eEthnicity = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientAddress::EnumEthnicity::Unknown; \
	s.eMaritalStatus = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientAddress::EnumMaritalStatus::Unknown; \
	INIT_SMEEXADDRESSSTRUCT(s.sAddress); \

typedef struct structSmeexPatientAddress {
	long lAddressRefID;
	long lPatientID;
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientAddress::EnumStatusType eStatusType;
	DATE dBirthdate;
	_bstr_t strSsn;
	_bstr_t strProfession;
	_bstr_t strNationality;
	_bstr_t strDenomination;
	_bstr_t strHmoAffiliation;
	_bstr_t strNationalLanguage;
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientAddress::EnumEthnicity eEthnicity;
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientAddress::EnumMaritalStatus eMaritalStatus;
	structSmeexAddress sAddress;
} structSmeexPatientAddress, *structSmeexPatientAddressPtr;

#define INIT_SMEEXDIAGNOSISSTRUCT(s) \
	s.strCodingEntryCode = _T(""); \
	s.strCodingEntryName = _T(""); \
	s.eCodingType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Diagnosis::EnumCodingType::Other; \
	s.dDate = COleDateTime(SMEEX_EMPTY_OLEDATETIME); \
	s.lID = 0; \
	s.lParentID = 0; \
	s.bIsActive = -1; \
	s.strName = _T(""); \
	s.strShortName = _T(""); \

typedef struct structSmeexDiagnosis {
	_bstr_t strCodingEntryCode;
	_bstr_t strCodingEntryName;
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Diagnosis::EnumCodingType eCodingType;
	DATE dDate;
	long lID;
	long lParentID;
	BOOL bIsActive;
	_bstr_t strName;
	_bstr_t strShortName;
} structSmeexDiagnosis, structSmeexDiagnosisPtr;

#define INIT_SMEEXPOSOLOGYSTRUCT(s) \
	s.dDateBegin = COleDateTime(SMEEX_EMPTY_OLEDATETIME); \
	s.dDateEnd = COleDateTime(SMEEX_EMPTY_OLEDATETIME); \
	s.lDocumentRefID = 0; \
	s.dQuantityMorning = 0; \
	s.dQuantityNoon = 0; \
	s.dQuantityEvening = 0; \
	s.dQuantityNight = 0; \
	s.strRemark = _T(""); \

typedef struct structSmeexPosology {
	DATE dDateBegin;
	DATE dDateEnd;
	long lDocumentRefID;
	double dQuantityMorning;
	double dQuantityNoon;
	double dQuantityEvening;
	double dQuantityNight;
	_bstr_t strRemark;
} structSmeexPosology, structSmeexPosology;
typedef std::vector< structSmeexPosology > SmeexPosologyArray;

#define INIT_SMEEXMEDICATIONSTRUCT(s) \
	s.strCodingEntryCode = _T(""); \
	s.strCodingEntryName = _T(""); \
	s.eCodingType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Medication::EnumCodingType::Other; \
	s.dDate = COleDateTime(SMEEX_EMPTY_OLEDATETIME); \
	s.lDocumentRefID = 0; \
	s.lID = 0; \
	s.bIsActive = -1; \
	s.bIsChronic = -1; \
	s.strName = _T(""); \
	s.strShortName = _T(""); \
	s.arPosology.clear(); \

typedef struct structSmeexMedication {
	_bstr_t strCodingEntryCode;
	_bstr_t strCodingEntryName;
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Medication::EnumCodingType eCodingType;
	DATE dDate;
	long lDocumentRefID;
	long lID;
	BOOL bIsActive;
	BOOL bIsChronic;
	_bstr_t strName;
	_bstr_t strShortName;
	SmeexPosologyArray arPosology;
} structSmeexMedication, structSmeexMedicationPtr;

#define INIT_SMEEXDOCUMENTSTRUCT(s) \
	s.strFilepath = _T(""); \
	s.lID = 0; \
	s.strMimeType = _T(""); \
	INIT_SMEEXADDRESSSTRUCT(s.sProducerAddress); \
	s.lSize = 0; \

typedef struct structSmeexDocument {
	_bstr_t strFilepath;
	long lID;
	_bstr_t strMimeType;
	structSmeexAddress sProducerAddress;
	long lSize;
} structSmeexDocument, structSmeexDocumentPtr;

#define INIT_SMEEXDOCUMENTLEAFSTRUCT(s) \
	s.strName = _T(""); \
	s.strComment = _T(""); \
	s.dDate = COleDateTime(SMEEX_EMPTY_OLEDATETIME); \
	s.lID = 0; \
	INIT_SMEEXDOCUMENTSTRUCT(s.sSmeexDocument); \

typedef struct structSmeexDocumentLeaf {
	_bstr_t strName;
	_bstr_t strComment;
	DATE dDate;
	long lID;
	structSmeexDocument sSmeexDocument;
} structSmeexDocumentLeaf, structSmeexDocumentLeafPtr;

typedef std::vector< structSmeexDocumentLeaf > SmeexDocumentLeafArray;
typedef std::map< long, SmeexDocumentLeafArray > SmeexDocumentLeafMap;

#define INIT_SMEEXDOCUMENTTREESTRUCT(s) \
	s.mapDocumentLeaf.clear(); \
	s.lDocumentTreeChildID = 0; \
	s.strName = _T(""); \

typedef struct structSmeexDocumentTree {
	long lDocumentTreeChildID;
	SmeexDocumentLeafMap mapDocumentLeaf;
	_bstr_t strName;
} structSmeexDocumentTree, structSmeexDocumentTreePtr;

typedef std::vector< structSmeexDiagnosis > SmeexDiagnosisArray;
typedef std::map< long, SmeexDiagnosisArray > SmeexDiagnosisMap;

typedef std::vector< structSmeexMedication > SmeexMedicationArray;

typedef std::vector< structSmeexDocumentTree > SmeexDocumentTreeArray;

typedef std::vector< structSmeexDocument > SmeexDocumentArray;
typedef std::vector< structSmeexAddress > SmeexAddressArray;

#define INIT_SMEEXKGSTRUCT(s) \
	s.mapDiagnosis.clear(); \
	s.arMedication.clear(); \

typedef struct structSmeexKg {
	SmeexDiagnosisMap mapDiagnosis;
	SmeexMedicationArray arMedication;
} structSmeexKg, structSmeexKgPtr;

/*
Allergy
Case
ClinicalResult
LabResult
Unemployability
Vaccination
*/

#define INIT_SMEEXPATIENTINFOSTRUCT(s) \
	s.lID = 0; \
	INIT_PATIENTADDRESSSTRUCT(s.sPatient); \
	INIT_SMEEXKGSTRUCT(s.sKg); \
	s.arDocumentTree.clear(); \

typedef struct structSmeexPatientInfo {
	long lID;
	structSmeexPatientAddress sPatient;
	structSmeexKg sKg;
	SmeexDocumentTreeArray arDocumentTree;
} structSmeexPatientInfo, *structSmeexPatientInfoPtr;
/*
GuarantorAddress
InsuranceAddress
EmployerAddress
OtherAddress
Treatment
*/

#define INIT_SMEEXONEPATIENTCOMMSTRUCT(s) \
	INIT_SMEEXARCHIVESTRUCT(s.sSmeexArchive); \
	INIT_PROCESSINGINFOSTRUCT(s.sProcessingInfo); \
	INIT_SMEEXPATIENTINFOSTRUCT(s.sPatientInfo); \
	s.arDocument.clear(); \
	s.arAddress.clear(); \

typedef struct structSmeexOnePatientComm {
	structSmeexArchive sSmeexArchive;
	structProcessingInfo sProcessingInfo;
	structSmeexPatientInfo sPatientInfo;
	SmeexDocumentArray arDocument;
	SmeexAddressArray arAddress;
} structSmeexOnePatientComm, *structSmeexOnePatientCommPtr;

#endif //__SMEEXSTRUCTS_H__